/*
* Copyright 2021 E.J.I.E., S.A.
*
* Licencia con arreglo a la EUPL, Versión 1.1 exclusivamente (la «Licencia»);
* Solo podrá usarse esta obra si se respeta la Licencia.
* Puede obtenerse una copia de la Licencia en
*
* http://ec.europa.eu/idabc/eupl.html
*
* Salvo cuando lo exija la legislación aplicable o se acuerde por escrito,
* el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
* SIN GARANT�?AS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
* Véase la Licencia en el idioma concreto que rige los permisos y limitaciones
* que establece la Licencia.
*/
package com.ejie.ad74a.service;

import java.io.IOException;
import java.io.OutputStream;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.CreationHelper;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.odftoolkit.odfdom.doc.OdfSpreadsheetDocument;
import org.odftoolkit.odfdom.doc.table.OdfTable;
import org.odftoolkit.odfdom.doc.table.OdfTableRow;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ad74a.dao.DocumentoPapel0Dao;
import com.ejie.ad74a.model.DocumentoPapel0;
import com.ejie.ad74a.ws.client.dokusi.service.DokusiService;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;
import com.lowagie.text.Document;
import com.lowagie.text.Phrase;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfWriter;

/**
 * DocumentoPapel0ServiceImpl generated by UDA, 19-abr-2023 10:08:13.
 * 
 * @author UDA
 */

@Service(value = "documentoPapel0Service")
public class DocumentoPapel0ServiceImpl implements DocumentoPapel0Service {

	@Autowired
	private DocumentoPapel0Dao documentoPapel0Dao;

	@Autowired
	private DokusiService dokusiService;

	/**
	 * Inserts a single row in the DocumentoPapel0 table.
	 *
	 * @param documentoPapel0 DocumentoPapel0
	 *
	 * @return DocumentoPapel0
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DocumentoPapel0 add(DocumentoPapel0 documentoPapel0) {
		return this.documentoPapel0Dao.add(documentoPapel0);
	}

	/**
	 * Updates a single row in the DocumentoPapel0 table.
	 *
	 * @param documentoPapel0 DocumentoPapel0
	 *
	 * @return DocumentoPapel0
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DocumentoPapel0 update(DocumentoPapel0 documentoPapel0) {
		return this.documentoPapel0Dao.update(documentoPapel0);
	}

	/**
	 * Finds a single row in the DocumentoPapel0 table.
	 *
	 * @param documentoPapel0 DocumentoPapel0
	 *
	 * @return DocumentoPapel0
	 */
	public DocumentoPapel0 find(DocumentoPapel0 documentoPapel0) {
		return (DocumentoPapel0) this.documentoPapel0Dao.find(documentoPapel0);
	}

	/**
	 * Deletes a single row in the DocumentoPapel0 table.
	 *
	 * @param documentoPapel0 DocumentoPapel0
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(DocumentoPapel0 documentoPapel0) {
		this.documentoPapel0Dao.remove(documentoPapel0);
	}

	/**
	 * Finds a list of rows in the DocumentoPapel0 table.
	 *
	 * @param documentoPapel0 DocumentoPapel0
	 * @param tableRequestDto TableRequestDto
	 *
	 * @return List<DocumentoPapel0>
	 */
	public List<DocumentoPapel0> findAll(DocumentoPapel0 documentoPapel0, TableRequestDto tableRequestDto) {
		return (List<DocumentoPapel0>) this.documentoPapel0Dao.findAll(documentoPapel0, tableRequestDto);
	}

	/**
	 * Finds rows in the DocumentoPapel0 table using like.
	 *
	 * @param documentoPapel0 DocumentoPapel0
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith      Boolean
	 * 
	 * @return List<DocumentoPapel0>
	 */
	public List<DocumentoPapel0> findAllLike(DocumentoPapel0 documentoPapel0, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return (List<DocumentoPapel0>) this.documentoPapel0Dao.findAllLike(documentoPapel0, tableRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the DocumentoPapel0 table.
	 *
	 * @param tableRequestDto TableRequestDto
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void removeMultiple(TableRequestDto tableRequestDto) {
		this.documentoPapel0Dao.removeMultiple(tableRequestDto);
	}

	/**
	 * Filter method in the DocumentoPapel0 table.
	 *
	 * @param filterDocumentoPapel0 DocumentoPapel0
	 * @param tableRequestDto       TableRequestDto
	 * @param startsWith            Boolean
	 *
	 * @return TableResourceResponseDto<DocumentoPapel0>
	 */
	public TableResponseDto<DocumentoPapel0> filter(DocumentoPapel0 filterDocumentoPapel0,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<DocumentoPapel0> listaDocumentoPapel0 = this.documentoPapel0Dao.findAllLike(filterDocumentoPapel0,
				tableRequestDto, false);
		Long recordNum = this.documentoPapel0Dao
				.findAllLikeCount(filterDocumentoPapel0 != null ? filterDocumentoPapel0 : new DocumentoPapel0(), false);
		TableResponseDto<DocumentoPapel0> tableResponseDto = new TableResponseDto<DocumentoPapel0>(tableRequestDto,
				recordNum, listaDocumentoPapel0);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null
				&& !tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
			List<TableRowDto<DocumentoPapel0>> reorderSelection = this.documentoPapel0Dao
					.reorderSelection(filterDocumentoPapel0, tableRequestDto, startsWith);
			tableResponseDto.setReorderedSelection(reorderSelection);
			tableResponseDto.addAdditionalParam("reorderedSelection", reorderSelection);
			tableResponseDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<DocumentoPapel0>> reorderSeeker = this.documentoPapel0Dao
					.reorderSelection(filterDocumentoPapel0, tableRequestDto, startsWith);
			tableResponseDto.setReorderedSeeker(reorderSeeker);
			tableResponseDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return tableResponseDto;
	}

	/**
	 * Searches rows in the DocumentoPapel0 table.
	 *
	 * @param filterDocumentoPapel0 DocumentoPapel0
	 * @param searchDocumentoPapel0 DocumentoPapel0
	 * @param tableRequestDto       TableRequestDto
	 * @param startsWith            Boolean
	 *
	 * @return List<TableRowDto<DocumentoPapel0>>
	 */
	public List<TableRowDto<DocumentoPapel0>> search(DocumentoPapel0 filterDocumentoPapel0,
			DocumentoPapel0 searchDocumentoPapel0, TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.documentoPapel0Dao.search(filterDocumentoPapel0, searchDocumentoPapel0, tableRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in DocumentoPapel0 table.
	 *
	 * @param filterDocumentoPapel0 DocumentoPapel0
	 * @param tableRequestDto       TableRequestDto
	 * @param startsWith            Boolean
	 *
	 * @return Object
	 */
	public Object reorderSelection(DocumentoPapel0 filterDocumentoPapel0, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.documentoPapel0Dao.reorderSelection(filterDocumentoPapel0, tableRequestDto, startsWith);
	}

	@Transactional(rollbackFor = Throwable.class)
	public List<DocumentoPapel0> getMultiple(DocumentoPapel0 filterDocumentoPapel0, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.documentoPapel0Dao.getMultiple(filterDocumentoPapel0, tableRequestDto, startsWith);
	}

	/**
	 * Devuelve un fichero en el formato deseado que contiene los datos exportados
	 * de la tabla.
	 *
	 * @param filterDocumentoPapel0 DocumentoPapel0
	 * @param columns               String[]
	 * @param columnsName           String[]
	 * @param fileName              String
	 * @param sheetTitle            String
	 * @param reportsParams         ArrayList<?>
	 * @param tableRequestDto       TableRequestDto
	 * @param request               HttpServletRequest
	 * @param response              HttpServletResponse
	 */
	@Override
	public void generateReport(DocumentoPapel0 filterDocumentoPapel0, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, ArrayList<?> reportsParams, TableRequestDto tableRequestDto,
			HttpServletRequest request, HttpServletResponse response) {
		// Accede a la DB para recuperar datos
		List<DocumentoPapel0> filteredData = getDataForReports(filterDocumentoPapel0, tableRequestDto);
		String extension = null;

		// Comprobar si las siguientes variables estan vacias, en caso de estarlo se las
		// asigna un valor generico
		fileName = (fileName != null && !fileName.isEmpty()) ? fileName : "report";
		sheetTitle = (sheetTitle != null && !sheetTitle.isEmpty()) ? sheetTitle : DocumentoPapel0.class.getSimpleName();

		// Obtener el formato de fecha especifico del locale
		SimpleDateFormat formatter = DateTimeManager.getDateTimeFormat(request.getLocale());

		// Cuando no se definen columnas porque se quieren obtener todas
		if (columns == null) {
			Field[] fields = DocumentoPapel0.class.getDeclaredFields();
			ArrayList<String> tempColumns = new ArrayList<String>();

			for (int i = 0; i < fields.length; i++) {
				try {
					String methodName = fields[i].getName();
					methodName = methodName.substring(0, 1).toUpperCase() + methodName.substring(1);
					DocumentoPapel0.class.getMethod("get" + methodName);
					tempColumns.add(fields[i].getName());
				} catch (NoSuchMethodException e) {
					e.printStackTrace();
				}

			}
			columns = tempColumns.toArray(new String[0]);
		}

		// Si no se definen los nombres de las columnas se dejan las definidas por
		// defecto
		if (columnsName == null) {
			columnsName = columns;
		}

		String servletPath = request.getServletPath();
		String reportType = null;
		if (servletPath.contains("/") && (servletPath.lastIndexOf("/") + 1 != servletPath.length())) {
			reportType = servletPath.substring(servletPath.lastIndexOf("/") + 1, servletPath.length());
		} else {
			reportType = servletPath.substring(0, servletPath.length());
		}

		if (reportType.equals("xlsReport")) {
			extension = ".xls";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("xlsxReport")) {
			extension = ".xlsx";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("pdfReport")) {
			extension = ".pdf";
			generatePDFReport(filteredData, columns, columnsName, fileName, response);
		} else if (reportType.equals("odsReport")) {
			extension = ".ods";
			generateODSReport(filteredData, columns, columnsName, fileName, sheetTitle, response);
		} else if (reportType.equals("csvReport")) {
			extension = ".csv";
			// Obtener idioma
			String language = request.getLocale().getLanguage();
			generateCSVReport(filteredData, columns, columnsName, fileName, sheetTitle, language, response);
		}

	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<DocumentoPapel0>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param extension    String
	 * @param formatter    SimpleDateFormat
	 * @param response     HttpServletResponse
	 */
	private void generateExcelReport(List<DocumentoPapel0> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String extension, SimpleDateFormat formatter,
			HttpServletResponse response) {
		try {
			// Creacion del Excel
			Workbook workbook = null;
			if (extension == ".xlsx") {
				workbook = new XSSFWorkbook();
				response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
			} else {
				workbook = new HSSFWorkbook();
				response.setContentType("application/vnd.ms-excel");
			}

			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + extension + "");

			// Creacion de una hoja y asignacion de su nombre
			Sheet sheet = workbook.createSheet(sheetTitle);

			// Se crea una fuente para estilizar las cabeceras
			Font headerFont = workbook.createFont();
			headerFont.setBold(true);
			headerFont.setFontHeightInPoints((short) 12);

			// Se crea un CellStyle con la fuente
			CellStyle headerCellStyle = workbook.createCellStyle();
			headerCellStyle.setAlignment(HorizontalAlignment.CENTER);
			headerCellStyle.setFont(headerFont);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Se crea la fila para insertar los titulos de las columnas
			Row row = sheet.createRow(rowNumber++);

			// Añadir titulos
			for (int i = 0; i < columnsName.length; i++) {
				Cell cell = row.createCell(i);
				cell.setCellValue(columnsName[i]);
				cell.setCellStyle(headerCellStyle);
			}

			// CreationHelper ayudara a mantener la compatibilidad del DataFormat tanto si
			// se crea un .xls como un .xlsx
			CreationHelper createHelper = workbook.getCreationHelper();

			// Se crea un CellStyle para añadir el formateador de fechas
			CellStyle dateCellStyle = workbook.createCellStyle();
			dateCellStyle.setDataFormat(createHelper.createDataFormat().getFormat(formatter.toPattern()));

			// Añadir datos
			for (DocumentoPapel0 rowDocumentoPapel0 : filteredData) {
				int cellNumber = 0;
				row = sheet.createRow(rowNumber++);

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					Cell cellDocumentoPapel0 = row.createCell(cellNumber++);
					cellDocumentoPapel0.setCellValue(getCellValue(column, rowDocumentoPapel0));
				}
			}

			// Se adapta el ancho de las columnas al contenido
			for (int i = 0; i < columns.length; i++) {
				sheet.autoSizeColumn(i);
			}

			// Se añade el fichero excel al response
			workbook.write(response.getOutputStream());
			workbook.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<DocumentoPapel0>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param response     HttpServletResponse
	 */
	private void generatePDFReport(List<DocumentoPapel0> filteredData, String[] columns, String[] columnsName,
			String fileName, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".pdf");
			response.setContentType("application/pdf");

			Document document = new Document();
			// Se añade el fichero pdf al response
			PdfWriter.getInstance(document, response.getOutputStream());

			document.open();

			PdfPTable table = new PdfPTable(columns.length);

			for (String column : columnsName) {
				PdfPCell header = new PdfPCell();
				header.setBorderWidth(2);
				header.setPhrase(new Phrase(column));
				table.addCell(header);
			}

			// Añadir datos
			for (DocumentoPapel0 rowDocumentoPapel0 : filteredData) {
				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					table.addCell(getCellValue(column, rowDocumentoPapel0));
				}
			}

			document.add(table);
			document.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<DocumentoPapel0>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param response     HttpServletResponse
	 */
	private void generateODSReport(List<DocumentoPapel0> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, HttpServletResponse response) {
		try {
			// Se añade el fichero ods al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".ods");
			response.setContentType("application/vnd.oasis.opendocument.spreadsheet");

			OdfSpreadsheetDocument ods = OdfSpreadsheetDocument.newSpreadsheetDocument();
			ods.getOrCreateDocumentStyles();

			// Hay que eliminar la hoja que se genera por defecto
			ods.getTableByName("Sheet1").remove();

			// Hoja nueva
			OdfTable table = OdfTable.newTable(ods, filteredData.size() + 1, columns.length);
			table.setTableName(sheetTitle);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Cabeceras
			OdfTableRow row = table.getRowByIndex(rowNumber++);
			for (int i = 0; i < columnsName.length; i++) {
				row.getCellByIndex(i).setStringValue(columnsName[i]);
			}

			// Añadir datos
			for (DocumentoPapel0 rowDocumentoPapel0 : filteredData) {
				row = table.getRowByIndex(rowNumber++);
				int cellNumber = 0;

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					row.getCellByIndex(cellNumber++).setStringValue(getCellValue(column, rowDocumentoPapel0));
				}
			}

			// Se añade el fichero ods al response
			ods.save(response.getOutputStream());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<DocumentoPapel0>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param language     String
	 * @param response     HttpServletResponse
	 */
	private void generateCSVReport(List<DocumentoPapel0> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String language, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".csv");
			response.setContentType("text/csv");

			// Separador de campos dependiendo del idioma
			String separator = ";";
			if (language.equals("en")) {
				separator = ",";
			}

			// Se añade el fichero csv al response
			OutputStream out = response.getOutputStream();
			// Añadir titulos
			boolean addTitles = true;

			// Añadir datos
			for (DocumentoPapel0 rowDocumentoPapel0 : filteredData) {
				int cellNumber = 1;
				StringBuilder columnsTitles = new StringBuilder();
				StringBuilder row = new StringBuilder();

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					String cellValue = getCellValue(column, rowDocumentoPapel0);

					if (cellNumber < columns.length) {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"");
							columnsTitles.append(separator);
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"");
						row.append(separator);
						cellNumber++;
					} else {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"\n");
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"\n");
					}
				}

				if (addTitles) {
					out.write(columnsTitles.toString().getBytes());
					addTitles = false;
				}
				out.write(row.toString().getBytes());
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve los datos recuperados de la DB.
	 *
	 * @param filterDocumentoPapel0 DocumentoPapel0
	 * @param tableRequestDto       TableRequestDto
	 *
	 * @return List<DocumentoPapel0>
	 */
	public List<DocumentoPapel0> getDataForReports(DocumentoPapel0 filterDocumentoPapel0,
			TableRequestDto tableRequestDto) {
		if (tableRequestDto.getMultiselection().getSelectedAll()
				&& tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
			if (filterDocumentoPapel0 != null) {
				return this.documentoPapel0Dao.findAllLike(filterDocumentoPapel0, tableRequestDto, false);
			} else {
				return this.documentoPapel0Dao.findAll(new DocumentoPapel0(), null);
			}
		} else {
			return this.documentoPapel0Dao.getMultiple(filterDocumentoPapel0, tableRequestDto, false);
		}
	}

	/**
	 * Obtiene los valores de las celdas.
	 *
	 * @param column             String
	 * @param rowDocumentoPapel0 DocumentoPapel0
	 *
	 * @return String
	 */
	private String getCellValue(String column, DocumentoPapel0 rowDocumentoPapel0) {
		String cellValue = "";
		try {
			cellValue = BeanUtils.getProperty(rowDocumentoPapel0, column) != null
					? BeanUtils.getProperty(rowDocumentoPapel0, column)
					: "";
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		}

		return cellValue;
	}

	/**
	 * Obtiene todos los documentos de una entrada del libro de registro
	 *
	 * @param filterDocumentoPapel0 DocumentoPapel0
	 *
	 * @return List<DocumentoPapel0>
	 */
	public List<DocumentoPapel0> getAllByEntrada(DocumentoPapel0 filterDocumentoPapel0) {
		List<DocumentoPapel0> listaDocumentoPapel0 = this.documentoPapel0Dao.findAllLike(filterDocumentoPapel0, null,
				false);

		return listaDocumentoPapel0;
	}

	/**
	 * Updates the roleId of a document
	 * 
	 * @param documentosEntrada DocumentosEntrada
	 * @return DocumentosEntrada
	 */
	@Transactional(rollbackFor = Throwable.class)
	public boolean updateRoleDocument(DocumentoPapel0 documentoPapel0, Long idTipoDocTipificar,
			com.ejie.ad74a.ws.client.dokusi.model.papel0.Documento docDokusi) {

		this.documentoPapel0Dao.updateNombre(documentoPapel0);
		documentoPapel0 = this.documentoPapel0Dao.updateRoleDocument(documentoPapel0);
		boolean resultado = false;
		// tramitamos despues de actualziar por si hay que hacer roolback
		// si ya tiene un idTipoDocTipificar, significa que ya se ha hecho el tramitate,
		// y hay que hacer retramitate

		if (null != idTipoDocTipificar && idTipoDocTipificar > -1) {
			resultado = this.dokusiService.reTramitateDocument(docDokusi);
		} else {
			resultado = this.dokusiService.tramitateDocument(docDokusi);
		}

		return resultado;
	}

	/**
	 * Updates the extension of a document
	 * 
	 * @param documentosEntrada DocumentosEntrada
	 * @return DocumentosEntrada
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DocumentoPapel0 updateExtension(DocumentoPapel0 documentoPapel0) {
		return this.documentoPapel0Dao.updateExtension(documentoPapel0);
	}

	@Transactional(rollbackFor = Throwable.class)
	public DocumentoPapel0 updateNombre(DocumentoPapel0 documentoPapel0) {
		return this.documentoPapel0Dao.updateNombre(documentoPapel0);
	}

	/**
	 * Updates the expediente of a document
	 * 
	 * @param documentosEntrada DocumentosEntrada
	 * @return DocumentosEntrada
	 */
	@Transactional(rollbackFor = Throwable.class)
	public DocumentoPapel0 updateExpediente(DocumentoPapel0 documentoPapel0) {
		return this.documentoPapel0Dao.updateExpediente(documentoPapel0);
	}
}
